diff --git a/src/include/access/nbtree.h b/src/include/access/nbtree.h
index 65d9698b89..9ed89cbff9 100644
--- a/src/include/access/nbtree.h
+++ b/src/include/access/nbtree.h
@@ -23,6 +23,7 @@
 #include "lib/stringinfo.h"
 #include "storage/bufmgr.h"
 #include "storage/shm_toc.h"
+#include "utils/rel.h"
 
 /* There's room for a 16-bit vacuum cycle ID in BTPageOpaqueData */
 typedef uint16 BTCycleId;
@@ -963,6 +964,7 @@ typedef struct BTOptions
 	/* fraction of newly inserted tuples prior to trigger index cleanup */
 	float8		vacuum_cleanup_index_scale_factor;
 	bool		deduplicate_items;	/* Try to deduplicate items? */
+	PageCompressOpts	compress; /* page compress related options */
 } BTOptions;
 
 #define BTGetFillFactor(relation) \
diff --git a/src/include/access/spgist_private.h b/src/include/access/spgist_private.h
index 00b98ec6a0..36d9a6e088 100644
--- a/src/include/access/spgist_private.h
+++ b/src/include/access/spgist_private.h
@@ -20,6 +20,7 @@
 #include "nodes/tidbitmap.h"
 #include "storage/buf.h"
 #include "utils/geo_decls.h"
+#include "utils/rel.h"
 #include "utils/relcache.h"
 
 
@@ -27,6 +28,7 @@ typedef struct SpGistOptions
 {
 	int32		varlena_header_;	/* varlena header (do not touch directly!) */
 	int			fillfactor;		/* page fill factor in percent (0..100) */
+	PageCompressOpts	compress; /* page compress related options */
 } SpGistOptions;
 
 #define SpGistGetFillFactor(relation) \
diff --git a/src/include/catalog/heap.h b/src/include/catalog/heap.h
index d31141c1a2..e22308e221 100644
--- a/src/include/catalog/heap.h
+++ b/src/include/catalog/heap.h
@@ -57,6 +57,7 @@ extern Relation heap_create(const char *relname,
 							char relpersistence,
 							bool shared_relation,
 							bool mapped_relation,
+							Datum reloptions,
 							bool allow_system_table_mods,
 							TransactionId *relfrozenxid,
 							MultiXactId *relminmxid);
diff --git a/src/include/commands/tablespace.h b/src/include/commands/tablespace.h
index fd1b28fca2..3069cd383c 100644
--- a/src/include/commands/tablespace.h
+++ b/src/include/commands/tablespace.h
@@ -18,6 +18,8 @@
 #include "catalog/objectaddress.h"
 #include "lib/stringinfo.h"
 #include "nodes/parsenodes.h"
+#include "storage/page_compression.h"
+#include "utils/rel.h"
 
 /* XLOG stuff */
 #define XLOG_TBLSPC_CREATE		0x00
@@ -41,6 +43,7 @@ typedef struct TableSpaceOpts
 	float8		seq_page_cost;
 	int			effective_io_concurrency;
 	int			maintenance_io_concurrency;
+	PageCompressOpts	compress; /* page compress related options */
 } TableSpaceOpts;
 
 extern Oid	CreateTableSpace(CreateTableSpaceStmt *stmt);
diff --git a/src/include/pg_config.h.in b/src/include/pg_config.h.in
index fb270df678..f335c399cb 100644
--- a/src/include/pg_config.h.in
+++ b/src/include/pg_config.h.in
@@ -346,6 +346,9 @@
 /* Define to 1 if you have the `z' library (-lz). */
 #undef HAVE_LIBZ
 
+/* Define to 1 if you have the `zstd' library (-lzstd). */
+#undef HAVE_LIBZSTD
+
 /* Define to 1 if you have the `link' function. */
 #undef HAVE_LINK
 
@@ -686,6 +689,9 @@
 /* Define to 1 if the assembler supports X86_64's POPCNTQ instruction. */
 #undef HAVE_X86_64_POPCNTQ
 
+/* Define to 1 if you have the <zstd.h> header file. */
+#undef HAVE_ZSTD_H
+
 /* Define to 1 if the system has the type `_Bool'. */
 #undef HAVE__BOOL
 
@@ -923,6 +929,9 @@
 /* Define to select Win32-style shared memory. */
 #undef USE_WIN32_SHARED_MEMORY
 
+/* Define to 1 to build with zstd support. (--with-zstd) */
+#undef USE_ZSTD
+
 /* Define to 1 if `wcstombs_l' requires <xlocale.h>. */
 #undef WCSTOMBS_L_IN_XLOCALE
 
diff --git a/src/include/pgstat.h b/src/include/pgstat.h
index 343eef507e..a5a4de4e9d 100644
--- a/src/include/pgstat.h
+++ b/src/include/pgstat.h
@@ -1008,7 +1008,9 @@ typedef enum
 	WAIT_EVENT_LOGICAL_CHANGES_READ,
 	WAIT_EVENT_LOGICAL_CHANGES_WRITE,
 	WAIT_EVENT_LOGICAL_SUBXACT_READ,
-	WAIT_EVENT_LOGICAL_SUBXACT_WRITE
+	WAIT_EVENT_LOGICAL_SUBXACT_WRITE,
+	WAIT_EVENT_COMPRESS_ADDRESS_FILE_FLUSH,
+	WAIT_EVENT_COMPRESS_ADDRESS_FILE_SYNC
 } WaitEventIO;
 
 /* ----------
diff --git a/src/include/storage/checksum_impl.h b/src/include/storage/checksum_impl.h
index 364acfafd2..402011900a 100644
--- a/src/include/storage/checksum_impl.h
+++ b/src/include/storage/checksum_impl.h
@@ -143,7 +143,7 @@ do { \
  * (at least on 4-byte boundary).
  */
 static uint32
-pg_checksum_block(const PGChecksummablePage *page)
+pg_checksum_block(const PGChecksummablePage *page, size_t size)
 {
 	uint32		sums[N_SUMS];
 	uint32		result = 0;
@@ -157,7 +157,7 @@ pg_checksum_block(const PGChecksummablePage *page)
 	memcpy(sums, checksumBaseOffsets, sizeof(checksumBaseOffsets));
 
 	/* main checksum calculation */
-	for (i = 0; i < (uint32) (BLCKSZ / (sizeof(uint32) * N_SUMS)); i++)
+	for (i = 0; i < (uint32) (size / (sizeof(uint32) * N_SUMS)); i++)
 		for (j = 0; j < N_SUMS; j++)
 			CHECKSUM_COMP(sums[j], page->data[i][j]);
 
@@ -201,7 +201,7 @@ pg_checksum_page(char *page, BlockNumber blkno)
 	 */
 	save_checksum = cpage->phdr.pd_checksum;
 	cpage->phdr.pd_checksum = 0;
-	checksum = pg_checksum_block(cpage);
+	checksum = pg_checksum_block(cpage, BLCKSZ);
 	cpage->phdr.pd_checksum = save_checksum;
 
 	/* Mix in the block number to detect transposed pages */
@@ -212,4 +212,4 @@ pg_checksum_page(char *page, BlockNumber blkno)
 	 * one. That avoids checksums of zero, which seems like a good idea.
 	 */
 	return (uint16) ((checksum % 65535) + 1);
-}
+}
\ No newline at end of file
diff --git a/src/include/storage/fd.h b/src/include/storage/fd.h
index e209f047e8..9fa562f3d1 100644
--- a/src/include/storage/fd.h
+++ b/src/include/storage/fd.h
@@ -132,6 +132,10 @@ extern void ReleaseExternalFD(void);
 /* Make a directory with default permissions */
 extern int	MakePGDirectory(const char *directoryName);
 
+/* Page compression support routines */
+extern void SetupPageCompressMemoryMap(File file, int chunk_size, uint8 algorithm);
+extern void *GetPageCompressMemoryMap(File file, int chunk_size);
+
 /* Miscellaneous support routines */
 extern void InitFileAccess(void);
 extern void set_max_safe_fds(void);
diff --git a/src/include/storage/page_compression.h b/src/include/storage/page_compression.h
new file mode 100644
index 0000000000..153e595b1f
--- /dev/null
+++ b/src/include/storage/page_compression.h
@@ -0,0 +1,140 @@
+/*
+ * page_compression.h
+ *		internal declarations for page compression
+ *
+ * Copyright (c) 2020, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *		src/include/storage/page_compression.h
+ */
+
+#ifndef PAGE_COMPRESSION_H
+#define PAGE_COMPRESSION_H
+
+#include <sys/mman.h>
+
+#include "storage/bufpage.h"
+//#include "utils/rel.h"
+#include "datatype/timestamp.h"
+
+#ifdef FRONTEND
+typedef uint32 pg_atomic_uint32;
+#else
+#include "port/atomics.h"
+#include "utils/rel.h"
+
+/* The page compression feature relies on native atomic operation support.
+ * On platforms that do not support native atomic operations, the members
+ * of pg_atomic_uint32 contain semaphore objects, which will affect the 
+ * persistence of compressed page address files.
+ */
+#define SUPPORT_PAGE_COMPRESSION (sizeof(pg_atomic_uint32) == sizeof(uint32))
+#endif
+
+/* In order to avoid the inconsistency of address metadata data when the server
+ * is down, it is necessary to prevent the address metadata of one data block
+ * from crossing two storage device blocks. The block size of ordinary storage
+ * devices is a multiple of 512, so 512 is used as the block size of the
+ * compressed address file. 
+ */
+#define COMPRESS_ADDR_BLCKSZ 512
+
+/* COMPRESS_ALGORITHM_XXX must be the same as COMPRESS_TYPE_XXX */
+#define COMPRESS_ALGORITHM_PGLZ 1
+#define COMPRESS_ALGORITHM_ZSTD 2
+
+typedef uint32 pc_chunk_number_t;
+
+/*
+ * layout of files for Page Compress:
+ *
+ * 1. page compression address file(_pca)
+ * - PageCompressHeader
+ * - PageCompressAddr[]
+ *
+ * 2. page compression data file(_pcd)
+ * - PageCompressData[]
+ *
+ */
+
+typedef struct PageCompressHeader
+{
+	pg_atomic_uint32	nblocks;	/* number of total blocks in this segment */
+	pg_atomic_uint32	allocated_chunks;	/* number of total allocated chunks in data area */
+	uint16				chunk_size;	/* size of each chunk, must be 1/2 1/4 or 1/8 of BLCKSZ */
+	uint8				algorithm;	/* compress algorithm, 1=pglz, 2=lz4 */
+	pg_atomic_uint32	last_synced_nblocks;	/* last synced nblocks */
+	pg_atomic_uint32	last_synced_allocated_chunks;	/* last synced allocated_chunks */
+	TimestampTz			last_recovery_start_time; 	/* postmaster start time of last recovery */
+} PageCompressHeader;
+
+typedef struct PageCompressAddr
+{
+	volatile uint8		nchunks;			/* number of chunks for this block */
+	volatile uint8		allocated_chunks;	/* number of allocated chunks for this block */
+
+	/* variable-length fields, 1 based chunk no array for this block, size of the array must be 2, 4 or 8 */
+	pc_chunk_number_t	chunknos[FLEXIBLE_ARRAY_MEMBER];
+} PageCompressAddr;
+
+typedef struct PageCompressData
+{
+	char	page_header[SizeOfPageHeaderData];	/* page header */
+	uint32	size;								/* size of compressed data */
+	char	data[FLEXIBLE_ARRAY_MEMBER];		/* compressed page, except for the page header */
+} PageCompressData;
+
+
+#define SizeOfPageCompressHeaderData sizeof(PageCompressHeader)
+#define SizeOfPageCompressAddrHeaderData offsetof(PageCompressAddr, chunknos)
+#define SizeOfPageCompressDataHeaderData offsetof(PageCompressData, data)
+
+#define SizeOfPageCompressAddr(chunk_size) \
+	(SizeOfPageCompressAddrHeaderData + sizeof(pc_chunk_number_t) * (BLCKSZ / (chunk_size)))
+
+#define NumberOfPageCompressAddrPerBlock(chunk_size) \
+	(COMPRESS_ADDR_BLCKSZ / SizeOfPageCompressAddr(chunk_size))
+
+#define OffsetOfPageCompressAddr(chunk_size, blockno) \
+	(COMPRESS_ADDR_BLCKSZ * (1 + (blockno) / NumberOfPageCompressAddrPerBlock(chunk_size)) \
+	+ SizeOfPageCompressAddr(chunk_size) * ((blockno) % NumberOfPageCompressAddrPerBlock(chunk_size)))
+
+#define GetPageCompressAddr(pcbuffer, chunk_size, blockno) \
+	(PageCompressAddr *)((char *)(pcbuffer) + OffsetOfPageCompressAddr((chunk_size),(blockno) % RELSEG_SIZE))
+
+#define SizeofPageCompressAddrFile(chunk_size) \
+	OffsetOfPageCompressAddr((chunk_size), RELSEG_SIZE)
+
+#define OffsetOfPageCompressChunk(chunk_size, chunkno) \
+	((chunk_size) * ((chunkno) - 1))
+
+#define MAX_PAGE_COMPRESS_ADDRESS_FILE_SIZE SizeofPageCompressAddrFile(BLCKSZ / 8)
+
+/* Abnormal scenarios may cause holes in the space allocation of data files,
+ * causing data file expansion. Usually the holes are not too big, so the definition
+ * allows a maximum of 10,000 chunks for holes. If allocated_chunks exceeds this value,
+ * VACUUM FULL needs to be executed to reclaim space.
+ */
+#define MAX_CHUNK_NUMBER(chunk_size) (RELSEG_SIZE * (BLCKSZ / (chunk_size)) + 10000)
+
+/* Compress function */
+extern int compress_page_buffer_bound(uint8 algorithm);
+extern int compress_page(const char *src, char *dst, int dst_size, uint8 algorithm, int8 level);
+extern int decompress_page(const char * src, char *dst, uint8 algorithm);
+
+/* Memory mapping function */
+extern PageCompressHeader * pc_mmap(int fd, int chunk_size, bool readonly);
+extern int pc_munmap(PageCompressHeader * map);
+extern int pc_msync(PageCompressHeader * map);
+
+
+#ifndef FRONTEND
+extern int compress_address_flush_chunks;
+
+/* compression options function */
+extern Datum buildCompressReloptions(PageCompressOpts *pcOpt);
+
+extern void check_and_repair_compress_address(PageCompressHeader *pcMap, uint16 chunk_size, uint8 algorithm, const char *path);
+#endif
+
+#endif							/* PAGE_COMPRESSION_H */
diff --git a/src/include/storage/page_compression_impl.h b/src/include/storage/page_compression_impl.h
new file mode 100644
index 0000000000..35eefd30ee
--- /dev/null
+++ b/src/include/storage/page_compression_impl.h
@@ -0,0 +1,238 @@
+#include <stdio.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <linux/falloc.h>
+#include <sys/stat.h>
+#include <assert.h>
+#include <sys/mman.h>
+
+#include "common/pg_lzcompress.h"
+
+#ifdef USE_ZSTD
+#include <zstd.h>
+
+#define DEFAULT_ZSTD_COMPRESSION_LEVEL 1
+#define MIN_ZSTD_COMPRESSION_LEVEL ZSTD_minCLevel()
+#define MAX_ZSTD_COMPRESSION_LEVEL ZSTD_maxCLevel()
+#endif
+
+
+/**
+ * compress_page_buffer_bound()
+ * -- Get the destination buffer boundary to compress one page.
+ * 
+ * Return needed destination buffer size for compress one page or
+ *     -1 for unrecognized compression algorithm
+ * 
+ */
+int
+compress_page_buffer_bound(uint8 algorithm)
+{
+	switch(algorithm)
+	{
+		case COMPRESS_ALGORITHM_PGLZ:
+			return BLCKSZ + 4;
+#ifdef USE_ZSTD
+		case COMPRESS_ALGORITHM_ZSTD:
+            return ZSTD_compressBound(BLCKSZ - SizeOfPageHeaderData);
+#endif
+		default:
+			return -1;
+			break;
+	}
+}
+
+/**
+ * compress_page() -- Compress one page.
+ * 
+ *		Only the parts other than the page header will be compressed. The
+ *		compressed data is rounded by chunck_size, The insufficient part is
+ *		filled with zero.  Compression needs to be able to save at least one
+ *		chunk of space, otherwise it fail.
+ *		This function returen the size of compressed data or
+ *		    -1 for compression fail
+ *		    -2 for unrecognized compression algorithm
+ */
+int
+compress_page(const char *src, char *dst, int dst_size, uint8 algorithm, int8 level)
+{
+	int                 compressed_size;
+	PageCompressData    *pcdptr;
+
+    pcdptr = (PageCompressData *)dst;
+
+	switch(algorithm)
+	{
+		case COMPRESS_ALGORITHM_PGLZ:
+			compressed_size = pglz_compress(src + SizeOfPageHeaderData,
+											BLCKSZ - SizeOfPageHeaderData,
+											pcdptr->data,
+											PGLZ_strategy_always);
+			break;
+#ifdef USE_ZSTD
+		case COMPRESS_ALGORITHM_ZSTD:
+		{
+			if(level == 0 ||
+               level < MIN_ZSTD_COMPRESSION_LEVEL ||
+               level > MAX_ZSTD_COMPRESSION_LEVEL)
+				level = DEFAULT_ZSTD_COMPRESSION_LEVEL;
+
+			compressed_size = ZSTD_compress(pcdptr->data,
+							dst_size,
+							src + SizeOfPageHeaderData,
+							BLCKSZ - SizeOfPageHeaderData,
+							level);
+
+			if (ZSTD_isError(compressed_size))
+			{
+				return -1;
+			}
+			break;
+		}
+#endif
+		default:
+			return -2;
+			break;
+	}
+
+	if(compressed_size < 0)
+		return -1;
+
+	memcpy(pcdptr->page_header, src, SizeOfPageHeaderData);
+	pcdptr->size = compressed_size;
+
+	return SizeOfPageCompressDataHeaderData + compressed_size;
+}
+
+/**
+ * decompress_page() -- Decompress one compressed page.
+ *  return size of decompressed page which should be BLCKSZ or
+ *         -1 for decompress error
+ *         -2 for unrecognized compression algorithm
+ * 
+ * 		note:The size of dst must be greater than or equal to BLCKSZ.
+ */
+int
+decompress_page(const char * src, char *dst, uint8 algorithm)
+{
+	int			decompressed_size;
+	PageCompressData *pcdptr;
+
+	pcdptr = (PageCompressData *)src;
+
+	memcpy(dst, src, SizeOfPageHeaderData);
+
+	switch(algorithm)
+	{
+		case COMPRESS_ALGORITHM_PGLZ:
+			decompressed_size = pglz_decompress(pcdptr->data,
+												pcdptr->size,
+												dst + SizeOfPageHeaderData,
+												BLCKSZ - SizeOfPageHeaderData,
+												false);
+			break;
+
+#ifdef USE_ZSTD
+		case COMPRESS_ALGORITHM_ZSTD:
+			decompressed_size = ZSTD_decompress(dst + SizeOfPageHeaderData,
+												BLCKSZ - SizeOfPageHeaderData,
+												pcdptr->data,
+												pcdptr->size);
+
+			if (ZSTD_isError(decompressed_size))
+			{
+				return -1;
+			}
+
+			break;
+#endif
+
+		default:
+            return -2;
+			break;
+
+	}
+
+	return SizeOfPageHeaderData + decompressed_size;
+}
+
+
+/**
+ * pc_mmap() -- create memory map for page compress file's address area.
+ * 
+ */
+PageCompressHeader *
+pc_mmap(int fd, int chunk_size, bool readonly)
+{
+	PageCompressHeader  *map;
+	int 				file_size,pc_memory_map_size;
+
+	pc_memory_map_size = SizeofPageCompressAddrFile(chunk_size);
+
+	file_size = lseek(fd, 0, SEEK_END);
+	if(file_size != pc_memory_map_size)
+	{
+		if (ftruncate(fd, pc_memory_map_size) != 0)
+			return (PageCompressHeader *) MAP_FAILED;
+	}
+
+#ifdef WIN32
+	{
+		HANDLE		mh;
+		if(readonly)
+			mh = CreateSnapshotMapping((HANDLE)_get_osfhandle(fd), NULL, PAGE_READONLY,
+										   		0, (DWORD) pc_memory_map_size, NULL);
+		else
+			mh = CreateSnapshotMapping((HANDLE)_get_osfhandle(fd), NULL, PAGE_READWRITE,
+										   		0, (DWORD) pc_memory_map_size, NULL);
+
+		if (mh == NULL)
+			return (PageCompressHeader *) MAP_FAILED;
+
+		map = (PageCompressHeader *) MapViewOfFile(mh, FILE_MAP_ALL_ACCESS, 0, 0, 0);
+		CloseHandle(mh);
+	}
+	if (map == NULL)
+		return (PageCompressHeader *) MAP_FAILED;
+
+#else
+	if(readonly)
+        map = (PageCompressHeader *) mmap(NULL, pc_memory_map_size, PROT_READ, MAP_SHARED, fd, 0);
+	else
+		map = (PageCompressHeader *) mmap(NULL, pc_memory_map_size, PROT_WRITE | PROT_READ, MAP_SHARED, fd, 0);
+#endif
+	return map;
+}
+
+/**
+ * pc_munmap() -- release memory map of page compress file.
+ * 
+ */
+int
+pc_munmap(PageCompressHeader * map)
+{
+#ifdef WIN32
+	return UnmapViewOfFile(map) ? 0 : -1;
+#else
+	return munmap(map, SizeofPageCompressAddrFile(map->chunk_size));
+#endif
+}
+
+/**
+ * pc_msync() -- sync memory map of page compress file.
+ * 
+ */
+int
+pc_msync(PageCompressHeader *map)
+{
+#ifndef FRONTEND
+	if (!enableFsync)
+		return 0;
+#endif
+
+#ifdef WIN32
+	return FlushViewOfFile(map, SizeofPageCompressAddrFile(map->chunk_size)) ? 0 : -1;
+#else
+	return msync(map, SizeofPageCompressAddrFile(map->chunk_size), MS_SYNC);
+#endif
+}
\ No newline at end of file
diff --git a/src/include/storage/relfilenode.h b/src/include/storage/relfilenode.h
index 4de9fc1e69..008b97755b 100644
--- a/src/include/storage/relfilenode.h
+++ b/src/include/storage/relfilenode.h
@@ -59,6 +59,10 @@ typedef struct RelFileNode
 	Oid			spcNode;		/* tablespace */
 	Oid			dbNode;			/* database */
 	Oid			relNode;		/* relation */
+	uint32		compress_chunk_size;		/* chunk size of compressed data */
+	uint8		compress_algorithm;			/* compress algorithm */
+	int8		compresslevel;				/* compress level */
+	uint8		compress_prealloc_chunks;	/* prealloced chunks to store compressed data */
 } RelFileNode;
 
 /*
diff --git a/src/include/utils/guc_tables.h b/src/include/utils/guc_tables.h
index 04431d0eb2..7dfb4cf7b0 100644
--- a/src/include/utils/guc_tables.h
+++ b/src/include/utils/guc_tables.h
@@ -96,6 +96,7 @@ enum config_group
 	CLIENT_CONN_PRELOAD,
 	CLIENT_CONN_OTHER,
 	LOCK_MANAGEMENT,
+	COMPRESS_OPTIONS,
 	COMPAT_OPTIONS,
 	COMPAT_OPTIONS_PREVIOUS,
 	COMPAT_OPTIONS_CLIENT,
diff --git a/src/include/utils/rel.h b/src/include/utils/rel.h
index 0b5957ba02..e36c793fca 100644
--- a/src/include/utils/rel.h
+++ b/src/include/utils/rel.h
@@ -294,6 +294,23 @@ typedef struct AutoVacOpts
 	float8		analyze_scale_factor;
 } AutoVacOpts;
 
+/* PageCompressOpts->compresstype values */
+typedef enum compressTypeOption
+{
+	COMPRESS_TYPE_NONE = 0,
+	COMPRESS_TYPE_PGLZ = 1,
+	COMPRESS_TYPE_ZSTD = 2
+} compressTypeOption;
+
+ /* page compress related reloptions. */
+typedef struct PageCompressOpts
+{
+	compressTypeOption	compresstype; 				/* compress algorithm */
+	int					compresslevel;		/* compress level */
+	int					compress_chunk_size;		/* chunk size of compressed data */
+	int					compress_prealloc_chunks;	/* prealloced chunks to store compressed data */
+} PageCompressOpts;
+
 typedef struct StdRdOptions
 {
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
@@ -305,6 +322,7 @@ typedef struct StdRdOptions
 	int			parallel_workers;	/* max number of parallel workers */
 	bool		vacuum_index_cleanup;	/* enables index vacuuming and cleanup */
 	bool		vacuum_truncate;	/* enables vacuum to truncate a relation */
+	PageCompressOpts	compress; /* page compress related reloptions. */
 } StdRdOptions;
 
 #define HEAP_MIN_FILLFACTOR			10
diff --git a/src/include/utils/relcache.h b/src/include/utils/relcache.h
index 9a85b7dd57..259ec2a753 100644
--- a/src/include/utils/relcache.h
+++ b/src/include/utils/relcache.h
@@ -106,7 +106,8 @@ extern Relation RelationBuildLocalRelation(const char *relname,
 										   bool shared_relation,
 										   bool mapped_relation,
 										   char relpersistence,
-										   char relkind);
+										   char relkind,
+										   Datum reloptions);
 
 /*
  * Routines to manage assignment of new relfilenode to a relation
diff --git a/src/include/utils/spccache.h b/src/include/utils/spccache.h
index 7e4ec69aa2..a33acf02f3 100644
--- a/src/include/utils/spccache.h
+++ b/src/include/utils/spccache.h
@@ -13,9 +13,12 @@
 #ifndef SPCCACHE_H
 #define SPCCACHE_H
 
+#include "utils/rel.h"
+
 void		get_tablespace_page_costs(Oid spcid, float8 *spc_random_page_cost,
 									  float8 *spc_seq_page_cost);
 int			get_tablespace_io_concurrency(Oid spcid);
 int			get_tablespace_maintenance_io_concurrency(Oid spcid);
+PageCompressOpts	*get_tablespace_compression_option(Oid spcid);
 
 #endif							/* SPCCACHE_H */
diff --git a/src/test/Makefile b/src/test/Makefile
index efb206aa75..35ef7ccac8 100644
--- a/src/test/Makefile
+++ b/src/test/Makefile
@@ -14,6 +14,10 @@ include $(top_builddir)/src/Makefile.global
 
 SUBDIRS = perl regress isolation modules authentication recovery subscription
 
+ifeq ($(with_zstd),yes)
+SUBDIRS += zstd
+endif
+
 # Test suites that are not safe by default but can be run if selected
 # by the user via the whitespace-separated list in variable
 # PG_TEST_EXTRA:
diff --git a/src/test/README b/src/test/README
index b5ccfc0cf6..63ad9903fc 100644
--- a/src/test/README
+++ b/src/test/README
@@ -45,3 +45,6 @@ subscription/
 
 thread/
   A thread-safety-testing utility used by configure
+
+zstd/
+  Tests for page compression with zstd
diff --git a/src/test/recovery/t/001_stream_rep.pl b/src/test/recovery/t/001_stream_rep.pl
index 9e31a53de7..1e094896de 100644
--- a/src/test/recovery/t/001_stream_rep.pl
+++ b/src/test/recovery/t/001_stream_rep.pl
@@ -3,7 +3,7 @@ use strict;
 use warnings;
 use PostgresNode;
 use TestLib;
-use Test::More tests => 36;
+use Test::More tests => 38;
 
 # Initialize primary node
 my $node_primary = get_new_node('primary');
@@ -43,6 +43,9 @@ $node_standby_2->start;
 $node_primary->safe_psql('postgres',
 	"CREATE TABLE tab_int AS SELECT generate_series(1,1002) AS a");
 
+$node_primary->safe_psql('postgres',
+	"CREATE TABLE tab_int_compressed WITH(compresstype=pglz)AS SELECT generate_series(1,1002) AS a");
+
 # Wait for standbys to catch up
 $node_primary->wait_for_catchup($node_standby_1, 'replay',
 	$node_primary->lsn('insert'));
@@ -54,11 +57,21 @@ my $result =
 print "standby 1: $result\n";
 is($result, qq(1002), 'check streamed content on standby 1');
 
+my $result =
+  $node_standby_1->safe_psql('postgres', "SELECT count(*) FROM tab_int_compressed");
+print "standby 1: $result\n";
+is($result, qq(1002), 'check streamed content for compressed table on standby 1');
+
 $result =
   $node_standby_2->safe_psql('postgres', "SELECT count(*) FROM tab_int");
 print "standby 2: $result\n";
 is($result, qq(1002), 'check streamed content on standby 2');
 
+$result =
+  $node_standby_2->safe_psql('postgres', "SELECT count(*) FROM tab_int_compressed");
+print "standby 2: $result\n";
+is($result, qq(1002), 'check streamed content for compressed table on standby 2');
+
 # Check that only READ-only queries can run on standbys
 is($node_standby_1->psql('postgres', 'INSERT INTO tab_int VALUES (1)'),
 	3, 'read-only queries on standby 1');
diff --git a/src/test/regress/parallel_schedule b/src/test/regress/parallel_schedule
index 026ea880cd..e10e0cb73f 100644
--- a/src/test/regress/parallel_schedule
+++ b/src/test/regress/parallel_schedule
@@ -121,3 +121,6 @@ test: fast_default
 
 # run stats by itself because its delay may be insufficient under heavy load
 test: stats
+
+# run page_compression by itself temporarily
+test: page_compression
\ No newline at end of file
diff --git a/src/test/regress/serial_schedule b/src/test/regress/serial_schedule
index 979d926119..e3710e7532 100644
--- a/src/test/regress/serial_schedule
+++ b/src/test/regress/serial_schedule
@@ -201,3 +201,4 @@ test: explain
 test: event_trigger
 test: fast_default
 test: stats
+test: page_compression
